// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: attribute_config.proto

#include "attribute_config.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/port.h>
#include <google/protobuf/stubs/once.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/descriptor.h>
#include <google/protobuf/generated_message_reflection.h>
#include <google/protobuf/reflection_ops.h>
#include <google/protobuf/wire_format.h>
// This is a temporary google only hack
#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
#include "third_party/protobuf/version.h"
#endif
// @@protoc_insertion_point(includes)
namespace mascot {
class AttributeConfigDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<AttributeConfig>
      _instance;
} _AttributeConfig_default_instance_;
class AttributeConfigReplyDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<AttributeConfigReply>
      _instance;
} _AttributeConfigReply_default_instance_;
class EventPropertiesDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<EventProperties>
      _instance;
} _EventProperties_default_instance_;
class AttributeAlarmDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<AttributeAlarm>
      _instance;
} _AttributeAlarm_default_instance_;
}  // namespace mascot
namespace protobuf_attribute_5fconfig_2eproto {
void InitDefaultsAttributeConfigImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_attribute_5fconfig_2eproto::InitDefaultsAttributeAlarm();
  protobuf_attribute_5fconfig_2eproto::InitDefaultsEventProperties();
  {
    void* ptr = &::mascot::_AttributeConfig_default_instance_;
    new (ptr) ::mascot::AttributeConfig();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::AttributeConfig::InitAsDefaultInstance();
}

void InitDefaultsAttributeConfig() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsAttributeConfigImpl);
}

void InitDefaultsAttributeConfigReplyImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_error_2eproto::InitDefaultsError();
  protobuf_attribute_5fconfig_2eproto::InitDefaultsAttributeConfig();
  {
    void* ptr = &::mascot::_AttributeConfigReply_default_instance_;
    new (ptr) ::mascot::AttributeConfigReply();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::AttributeConfigReply::InitAsDefaultInstance();
}

void InitDefaultsAttributeConfigReply() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsAttributeConfigReplyImpl);
}

void InitDefaultsEventPropertiesImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_EventProperties_default_instance_;
    new (ptr) ::mascot::EventProperties();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::EventProperties::InitAsDefaultInstance();
}

void InitDefaultsEventProperties() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsEventPropertiesImpl);
}

void InitDefaultsAttributeAlarmImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::mascot::_AttributeAlarm_default_instance_;
    new (ptr) ::mascot::AttributeAlarm();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::mascot::AttributeAlarm::InitAsDefaultInstance();
}

void InitDefaultsAttributeAlarm() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsAttributeAlarmImpl);
}

::google::protobuf::Metadata file_level_metadata[4];

const ::google::protobuf::uint32 TableStruct::offsets[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, name_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, writable_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, data_format_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, data_type_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, memorized_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, mem_init_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, max_dim_x_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, max_dim_y_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, description_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, label_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, unit_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, standard_unit_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, display_unit_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, format_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, min_value_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, max_value_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, writable_attr_name_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, level_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, root_attr_name_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, enum_labels_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, att_alarm_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, event_prop_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, extensions_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfig, sys_extensions_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfigReply, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfigReply, success_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfigReply, error_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeConfigReply, data_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::EventProperties, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::EventProperties, empty_),
  ~0u,  // no _has_bits_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeAlarm, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::mascot::AttributeAlarm, empty_),
};
static const ::google::protobuf::internal::MigrationSchema schemas[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
  { 0, -1, sizeof(::mascot::AttributeConfig)},
  { 29, -1, sizeof(::mascot::AttributeConfigReply)},
  { 37, -1, sizeof(::mascot::EventProperties)},
  { 43, -1, sizeof(::mascot::AttributeAlarm)},
};

static ::google::protobuf::Message const * const file_default_instances[] = {
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_AttributeConfig_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_AttributeConfigReply_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_EventProperties_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::mascot::_AttributeAlarm_default_instance_),
};

void protobuf_AssignDescriptors() {
  AddDescriptors();
  ::google::protobuf::MessageFactory* factory = NULL;
  AssignDescriptors(
      "attribute_config.proto", schemas, file_default_instances, TableStruct::offsets, factory,
      file_level_metadata, NULL, NULL);
}

void protobuf_AssignDescriptorsOnce() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &protobuf_AssignDescriptors);
}

void protobuf_RegisterTypes(const ::std::string&) GOOGLE_PROTOBUF_ATTRIBUTE_COLD;
void protobuf_RegisterTypes(const ::std::string&) {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::internal::RegisterAllTypes(file_level_metadata, 4);
}

void AddDescriptorsImpl() {
  InitDefaults();
  static const char descriptor[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
      "\n\026attribute_config.proto\022\006mascot\032\021tango_"
      "enums.proto\032\013error.proto\"\327\004\n\017AttributeCo"
      "nfig\022\014\n\004name\030\001 \001(\t\022\'\n\010writable\030\002 \001(\0162\025.m"
      "ascot.AttrWriteType\022+\n\013data_format\030\003 \001(\016"
      "2\026.mascot.AttrDataFormat\022\021\n\tdata_type\030\004 "
      "\001(\003\022\021\n\tmemorized\030\005 \001(\010\022\020\n\010mem_init\030\006 \001(\010"
      "\022\021\n\tmax_dim_x\030\007 \001(\003\022\021\n\tmax_dim_y\030\010 \001(\003\022\023"
      "\n\013description\030\t \001(\t\022\r\n\005label\030\n \001(\t\022\014\n\004un"
      "it\030\013 \001(\t\022\025\n\rstandard_unit\030\014 \001(\t\022\024\n\014displ"
      "ay_unit\030\r \001(\t\022\016\n\006format\030\016 \001(\t\022\021\n\tmin_val"
      "ue\030\017 \001(\t\022\021\n\tmax_value\030\020 \001(\t\022\032\n\022writable_"
      "attr_name\030\021 \001(\t\022 \n\005level\030\022 \001(\0162\021.mascot."
      "DispLevel\022\026\n\016root_attr_name\030\023 \001(\t\022\023\n\013enu"
      "m_labels\030\024 \003(\t\022)\n\tatt_alarm\030\025 \001(\0132\026.masc"
      "ot.AttributeAlarm\022+\n\nevent_prop\030\026 \001(\0132\027."
      "mascot.EventProperties\022\022\n\nextensions\030\027 \003"
      "(\t\022\026\n\016sys_extensions\030\030 \003(\t\"l\n\024AttributeC"
      "onfigReply\022\017\n\007success\030\001 \001(\010\022\034\n\005error\030\002 \001"
      "(\0132\r.mascot.Error\022%\n\004data\030\003 \001(\0132\027.mascot"
      ".AttributeConfig\" \n\017EventProperties\022\r\n\005e"
      "mpty\030\001 \001(\t\"\037\n\016AttributeAlarm\022\r\n\005empty\030\001 "
      "\001(\tb\006proto3"
  };
  ::google::protobuf::DescriptorPool::InternalAddGeneratedFile(
      descriptor, 851);
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedFile(
    "attribute_config.proto", &protobuf_RegisterTypes);
  ::protobuf_tango_5fenums_2eproto::AddDescriptors();
  ::protobuf_error_2eproto::AddDescriptors();
}

void AddDescriptors() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &AddDescriptorsImpl);
}
// Force AddDescriptors() to be called at dynamic initialization time.
struct StaticDescriptorInitializer {
  StaticDescriptorInitializer() {
    AddDescriptors();
  }
} static_descriptor_initializer;
}  // namespace protobuf_attribute_5fconfig_2eproto
namespace mascot {

// ===================================================================

void AttributeConfig::InitAsDefaultInstance() {
  ::mascot::_AttributeConfig_default_instance_._instance.get_mutable()->att_alarm_ = const_cast< ::mascot::AttributeAlarm*>(
      ::mascot::AttributeAlarm::internal_default_instance());
  ::mascot::_AttributeConfig_default_instance_._instance.get_mutable()->event_prop_ = const_cast< ::mascot::EventProperties*>(
      ::mascot::EventProperties::internal_default_instance());
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int AttributeConfig::kNameFieldNumber;
const int AttributeConfig::kWritableFieldNumber;
const int AttributeConfig::kDataFormatFieldNumber;
const int AttributeConfig::kDataTypeFieldNumber;
const int AttributeConfig::kMemorizedFieldNumber;
const int AttributeConfig::kMemInitFieldNumber;
const int AttributeConfig::kMaxDimXFieldNumber;
const int AttributeConfig::kMaxDimYFieldNumber;
const int AttributeConfig::kDescriptionFieldNumber;
const int AttributeConfig::kLabelFieldNumber;
const int AttributeConfig::kUnitFieldNumber;
const int AttributeConfig::kStandardUnitFieldNumber;
const int AttributeConfig::kDisplayUnitFieldNumber;
const int AttributeConfig::kFormatFieldNumber;
const int AttributeConfig::kMinValueFieldNumber;
const int AttributeConfig::kMaxValueFieldNumber;
const int AttributeConfig::kWritableAttrNameFieldNumber;
const int AttributeConfig::kLevelFieldNumber;
const int AttributeConfig::kRootAttrNameFieldNumber;
const int AttributeConfig::kEnumLabelsFieldNumber;
const int AttributeConfig::kAttAlarmFieldNumber;
const int AttributeConfig::kEventPropFieldNumber;
const int AttributeConfig::kExtensionsFieldNumber;
const int AttributeConfig::kSysExtensionsFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

AttributeConfig::AttributeConfig()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_attribute_5fconfig_2eproto::InitDefaultsAttributeConfig();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.AttributeConfig)
}
AttributeConfig::AttributeConfig(const AttributeConfig& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      enum_labels_(from.enum_labels_),
      extensions_(from.extensions_),
      sys_extensions_(from.sys_extensions_),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.name().size() > 0) {
    name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.name_);
  }
  description_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.description().size() > 0) {
    description_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.description_);
  }
  label_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.label().size() > 0) {
    label_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.label_);
  }
  unit_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.unit().size() > 0) {
    unit_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.unit_);
  }
  standard_unit_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.standard_unit().size() > 0) {
    standard_unit_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.standard_unit_);
  }
  display_unit_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.display_unit().size() > 0) {
    display_unit_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.display_unit_);
  }
  format_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.format().size() > 0) {
    format_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.format_);
  }
  min_value_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.min_value().size() > 0) {
    min_value_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.min_value_);
  }
  max_value_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.max_value().size() > 0) {
    max_value_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.max_value_);
  }
  writable_attr_name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.writable_attr_name().size() > 0) {
    writable_attr_name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.writable_attr_name_);
  }
  root_attr_name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.root_attr_name().size() > 0) {
    root_attr_name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.root_attr_name_);
  }
  if (from.has_att_alarm()) {
    att_alarm_ = new ::mascot::AttributeAlarm(*from.att_alarm_);
  } else {
    att_alarm_ = NULL;
  }
  if (from.has_event_prop()) {
    event_prop_ = new ::mascot::EventProperties(*from.event_prop_);
  } else {
    event_prop_ = NULL;
  }
  ::memcpy(&writable_, &from.writable_,
    static_cast<size_t>(reinterpret_cast<char*>(&level_) -
    reinterpret_cast<char*>(&writable_)) + sizeof(level_));
  // @@protoc_insertion_point(copy_constructor:mascot.AttributeConfig)
}

void AttributeConfig::SharedCtor() {
  name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  description_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  label_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  unit_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  standard_unit_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  display_unit_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  format_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  min_value_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  max_value_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  writable_attr_name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  root_attr_name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  ::memset(&att_alarm_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&level_) -
      reinterpret_cast<char*>(&att_alarm_)) + sizeof(level_));
  _cached_size_ = 0;
}

AttributeConfig::~AttributeConfig() {
  // @@protoc_insertion_point(destructor:mascot.AttributeConfig)
  SharedDtor();
}

void AttributeConfig::SharedDtor() {
  name_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  description_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  label_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  unit_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  standard_unit_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  display_unit_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  format_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  min_value_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  max_value_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  writable_attr_name_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  root_attr_name_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (this != internal_default_instance()) delete att_alarm_;
  if (this != internal_default_instance()) delete event_prop_;
}

void AttributeConfig::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* AttributeConfig::descriptor() {
  ::protobuf_attribute_5fconfig_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_attribute_5fconfig_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const AttributeConfig& AttributeConfig::default_instance() {
  ::protobuf_attribute_5fconfig_2eproto::InitDefaultsAttributeConfig();
  return *internal_default_instance();
}

AttributeConfig* AttributeConfig::New(::google::protobuf::Arena* arena) const {
  AttributeConfig* n = new AttributeConfig;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void AttributeConfig::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.AttributeConfig)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  enum_labels_.Clear();
  extensions_.Clear();
  sys_extensions_.Clear();
  name_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  description_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  label_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  unit_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  standard_unit_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  display_unit_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  format_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  min_value_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  max_value_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  writable_attr_name_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  root_attr_name_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (GetArenaNoVirtual() == NULL && att_alarm_ != NULL) {
    delete att_alarm_;
  }
  att_alarm_ = NULL;
  if (GetArenaNoVirtual() == NULL && event_prop_ != NULL) {
    delete event_prop_;
  }
  event_prop_ = NULL;
  ::memset(&writable_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&level_) -
      reinterpret_cast<char*>(&writable_)) + sizeof(level_));
  _internal_metadata_.Clear();
}

bool AttributeConfig::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.AttributeConfig)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(16383u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // string name = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_name()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->name().data(), static_cast<int>(this->name().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.AttributeConfig.name"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.AttrWriteType writable = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(16u /* 16 & 0xFF */)) {
          int value;
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
          set_writable(static_cast< ::mascot::AttrWriteType >(value));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.AttrDataFormat data_format = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(24u /* 24 & 0xFF */)) {
          int value;
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
          set_data_format(static_cast< ::mascot::AttrDataFormat >(value));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // int64 data_type = 4;
      case 4: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(32u /* 32 & 0xFF */)) {

          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int64, ::google::protobuf::internal::WireFormatLite::TYPE_INT64>(
                 input, &data_type_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // bool memorized = 5;
      case 5: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(40u /* 40 & 0xFF */)) {

          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, &memorized_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // bool mem_init = 6;
      case 6: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(48u /* 48 & 0xFF */)) {

          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, &mem_init_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // int64 max_dim_x = 7;
      case 7: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(56u /* 56 & 0xFF */)) {

          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int64, ::google::protobuf::internal::WireFormatLite::TYPE_INT64>(
                 input, &max_dim_x_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // int64 max_dim_y = 8;
      case 8: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(64u /* 64 & 0xFF */)) {

          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   ::google::protobuf::int64, ::google::protobuf::internal::WireFormatLite::TYPE_INT64>(
                 input, &max_dim_y_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string description = 9;
      case 9: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(74u /* 74 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_description()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->description().data(), static_cast<int>(this->description().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.AttributeConfig.description"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string label = 10;
      case 10: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(82u /* 82 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_label()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->label().data(), static_cast<int>(this->label().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.AttributeConfig.label"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string unit = 11;
      case 11: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(90u /* 90 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_unit()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->unit().data(), static_cast<int>(this->unit().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.AttributeConfig.unit"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string standard_unit = 12;
      case 12: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(98u /* 98 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_standard_unit()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->standard_unit().data(), static_cast<int>(this->standard_unit().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.AttributeConfig.standard_unit"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string display_unit = 13;
      case 13: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(106u /* 106 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_display_unit()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->display_unit().data(), static_cast<int>(this->display_unit().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.AttributeConfig.display_unit"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string format = 14;
      case 14: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(114u /* 114 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_format()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->format().data(), static_cast<int>(this->format().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.AttributeConfig.format"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string min_value = 15;
      case 15: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(122u /* 122 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_min_value()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->min_value().data(), static_cast<int>(this->min_value().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.AttributeConfig.min_value"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string max_value = 16;
      case 16: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(130u /* 130 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_max_value()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->max_value().data(), static_cast<int>(this->max_value().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.AttributeConfig.max_value"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string writable_attr_name = 17;
      case 17: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(138u /* 138 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_writable_attr_name()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->writable_attr_name().data(), static_cast<int>(this->writable_attr_name().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.AttributeConfig.writable_attr_name"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.DispLevel level = 18;
      case 18: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(144u /* 144 & 0xFF */)) {
          int value;
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   int, ::google::protobuf::internal::WireFormatLite::TYPE_ENUM>(
                 input, &value)));
          set_level(static_cast< ::mascot::DispLevel >(value));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // string root_attr_name = 19;
      case 19: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(154u /* 154 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_root_attr_name()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->root_attr_name().data(), static_cast<int>(this->root_attr_name().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.AttributeConfig.root_attr_name"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // repeated string enum_labels = 20;
      case 20: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(162u /* 162 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->add_enum_labels()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->enum_labels(this->enum_labels_size() - 1).data(),
            static_cast<int>(this->enum_labels(this->enum_labels_size() - 1).length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.AttributeConfig.enum_labels"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.AttributeAlarm att_alarm = 21;
      case 21: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(170u /* 170 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_att_alarm()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.EventProperties event_prop = 22;
      case 22: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(178u /* 178 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_event_prop()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // repeated string extensions = 23;
      case 23: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(186u /* 186 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->add_extensions()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->extensions(this->extensions_size() - 1).data(),
            static_cast<int>(this->extensions(this->extensions_size() - 1).length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.AttributeConfig.extensions"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // repeated string sys_extensions = 24;
      case 24: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(194u /* 194 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->add_sys_extensions()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->sys_extensions(this->sys_extensions_size() - 1).data(),
            static_cast<int>(this->sys_extensions(this->sys_extensions_size() - 1).length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.AttributeConfig.sys_extensions"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.AttributeConfig)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.AttributeConfig)
  return false;
#undef DO_
}

void AttributeConfig::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.AttributeConfig)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string name = 1;
  if (this->name().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->name().data(), static_cast<int>(this->name().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.name");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->name(), output);
  }

  // .mascot.AttrWriteType writable = 2;
  if (this->writable() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteEnum(
      2, this->writable(), output);
  }

  // .mascot.AttrDataFormat data_format = 3;
  if (this->data_format() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteEnum(
      3, this->data_format(), output);
  }

  // int64 data_type = 4;
  if (this->data_type() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteInt64(4, this->data_type(), output);
  }

  // bool memorized = 5;
  if (this->memorized() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteBool(5, this->memorized(), output);
  }

  // bool mem_init = 6;
  if (this->mem_init() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteBool(6, this->mem_init(), output);
  }

  // int64 max_dim_x = 7;
  if (this->max_dim_x() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteInt64(7, this->max_dim_x(), output);
  }

  // int64 max_dim_y = 8;
  if (this->max_dim_y() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteInt64(8, this->max_dim_y(), output);
  }

  // string description = 9;
  if (this->description().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->description().data(), static_cast<int>(this->description().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.description");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      9, this->description(), output);
  }

  // string label = 10;
  if (this->label().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->label().data(), static_cast<int>(this->label().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.label");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      10, this->label(), output);
  }

  // string unit = 11;
  if (this->unit().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->unit().data(), static_cast<int>(this->unit().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.unit");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      11, this->unit(), output);
  }

  // string standard_unit = 12;
  if (this->standard_unit().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->standard_unit().data(), static_cast<int>(this->standard_unit().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.standard_unit");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      12, this->standard_unit(), output);
  }

  // string display_unit = 13;
  if (this->display_unit().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->display_unit().data(), static_cast<int>(this->display_unit().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.display_unit");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      13, this->display_unit(), output);
  }

  // string format = 14;
  if (this->format().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->format().data(), static_cast<int>(this->format().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.format");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      14, this->format(), output);
  }

  // string min_value = 15;
  if (this->min_value().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->min_value().data(), static_cast<int>(this->min_value().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.min_value");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      15, this->min_value(), output);
  }

  // string max_value = 16;
  if (this->max_value().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->max_value().data(), static_cast<int>(this->max_value().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.max_value");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      16, this->max_value(), output);
  }

  // string writable_attr_name = 17;
  if (this->writable_attr_name().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->writable_attr_name().data(), static_cast<int>(this->writable_attr_name().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.writable_attr_name");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      17, this->writable_attr_name(), output);
  }

  // .mascot.DispLevel level = 18;
  if (this->level() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteEnum(
      18, this->level(), output);
  }

  // string root_attr_name = 19;
  if (this->root_attr_name().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->root_attr_name().data(), static_cast<int>(this->root_attr_name().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.root_attr_name");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      19, this->root_attr_name(), output);
  }

  // repeated string enum_labels = 20;
  for (int i = 0, n = this->enum_labels_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->enum_labels(i).data(), static_cast<int>(this->enum_labels(i).length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.enum_labels");
    ::google::protobuf::internal::WireFormatLite::WriteString(
      20, this->enum_labels(i), output);
  }

  // .mascot.AttributeAlarm att_alarm = 21;
  if (this->has_att_alarm()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      21, *this->att_alarm_, output);
  }

  // .mascot.EventProperties event_prop = 22;
  if (this->has_event_prop()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      22, *this->event_prop_, output);
  }

  // repeated string extensions = 23;
  for (int i = 0, n = this->extensions_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->extensions(i).data(), static_cast<int>(this->extensions(i).length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.extensions");
    ::google::protobuf::internal::WireFormatLite::WriteString(
      23, this->extensions(i), output);
  }

  // repeated string sys_extensions = 24;
  for (int i = 0, n = this->sys_extensions_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->sys_extensions(i).data(), static_cast<int>(this->sys_extensions(i).length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.sys_extensions");
    ::google::protobuf::internal::WireFormatLite::WriteString(
      24, this->sys_extensions(i), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.AttributeConfig)
}

::google::protobuf::uint8* AttributeConfig::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.AttributeConfig)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string name = 1;
  if (this->name().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->name().data(), static_cast<int>(this->name().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.name");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->name(), target);
  }

  // .mascot.AttrWriteType writable = 2;
  if (this->writable() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteEnumToArray(
      2, this->writable(), target);
  }

  // .mascot.AttrDataFormat data_format = 3;
  if (this->data_format() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteEnumToArray(
      3, this->data_format(), target);
  }

  // int64 data_type = 4;
  if (this->data_type() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteInt64ToArray(4, this->data_type(), target);
  }

  // bool memorized = 5;
  if (this->memorized() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteBoolToArray(5, this->memorized(), target);
  }

  // bool mem_init = 6;
  if (this->mem_init() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteBoolToArray(6, this->mem_init(), target);
  }

  // int64 max_dim_x = 7;
  if (this->max_dim_x() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteInt64ToArray(7, this->max_dim_x(), target);
  }

  // int64 max_dim_y = 8;
  if (this->max_dim_y() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteInt64ToArray(8, this->max_dim_y(), target);
  }

  // string description = 9;
  if (this->description().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->description().data(), static_cast<int>(this->description().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.description");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        9, this->description(), target);
  }

  // string label = 10;
  if (this->label().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->label().data(), static_cast<int>(this->label().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.label");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        10, this->label(), target);
  }

  // string unit = 11;
  if (this->unit().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->unit().data(), static_cast<int>(this->unit().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.unit");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        11, this->unit(), target);
  }

  // string standard_unit = 12;
  if (this->standard_unit().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->standard_unit().data(), static_cast<int>(this->standard_unit().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.standard_unit");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        12, this->standard_unit(), target);
  }

  // string display_unit = 13;
  if (this->display_unit().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->display_unit().data(), static_cast<int>(this->display_unit().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.display_unit");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        13, this->display_unit(), target);
  }

  // string format = 14;
  if (this->format().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->format().data(), static_cast<int>(this->format().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.format");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        14, this->format(), target);
  }

  // string min_value = 15;
  if (this->min_value().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->min_value().data(), static_cast<int>(this->min_value().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.min_value");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        15, this->min_value(), target);
  }

  // string max_value = 16;
  if (this->max_value().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->max_value().data(), static_cast<int>(this->max_value().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.max_value");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        16, this->max_value(), target);
  }

  // string writable_attr_name = 17;
  if (this->writable_attr_name().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->writable_attr_name().data(), static_cast<int>(this->writable_attr_name().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.writable_attr_name");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        17, this->writable_attr_name(), target);
  }

  // .mascot.DispLevel level = 18;
  if (this->level() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteEnumToArray(
      18, this->level(), target);
  }

  // string root_attr_name = 19;
  if (this->root_attr_name().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->root_attr_name().data(), static_cast<int>(this->root_attr_name().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.root_attr_name");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        19, this->root_attr_name(), target);
  }

  // repeated string enum_labels = 20;
  for (int i = 0, n = this->enum_labels_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->enum_labels(i).data(), static_cast<int>(this->enum_labels(i).length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.enum_labels");
    target = ::google::protobuf::internal::WireFormatLite::
      WriteStringToArray(20, this->enum_labels(i), target);
  }

  // .mascot.AttributeAlarm att_alarm = 21;
  if (this->has_att_alarm()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        21, *this->att_alarm_, deterministic, target);
  }

  // .mascot.EventProperties event_prop = 22;
  if (this->has_event_prop()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        22, *this->event_prop_, deterministic, target);
  }

  // repeated string extensions = 23;
  for (int i = 0, n = this->extensions_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->extensions(i).data(), static_cast<int>(this->extensions(i).length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.extensions");
    target = ::google::protobuf::internal::WireFormatLite::
      WriteStringToArray(23, this->extensions(i), target);
  }

  // repeated string sys_extensions = 24;
  for (int i = 0, n = this->sys_extensions_size(); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->sys_extensions(i).data(), static_cast<int>(this->sys_extensions(i).length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeConfig.sys_extensions");
    target = ::google::protobuf::internal::WireFormatLite::
      WriteStringToArray(24, this->sys_extensions(i), target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.AttributeConfig)
  return target;
}

size_t AttributeConfig::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.AttributeConfig)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // repeated string enum_labels = 20;
  total_size += 2 *
      ::google::protobuf::internal::FromIntSize(this->enum_labels_size());
  for (int i = 0, n = this->enum_labels_size(); i < n; i++) {
    total_size += ::google::protobuf::internal::WireFormatLite::StringSize(
      this->enum_labels(i));
  }

  // repeated string extensions = 23;
  total_size += 2 *
      ::google::protobuf::internal::FromIntSize(this->extensions_size());
  for (int i = 0, n = this->extensions_size(); i < n; i++) {
    total_size += ::google::protobuf::internal::WireFormatLite::StringSize(
      this->extensions(i));
  }

  // repeated string sys_extensions = 24;
  total_size += 2 *
      ::google::protobuf::internal::FromIntSize(this->sys_extensions_size());
  for (int i = 0, n = this->sys_extensions_size(); i < n; i++) {
    total_size += ::google::protobuf::internal::WireFormatLite::StringSize(
      this->sys_extensions(i));
  }

  // string name = 1;
  if (this->name().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->name());
  }

  // string description = 9;
  if (this->description().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->description());
  }

  // string label = 10;
  if (this->label().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->label());
  }

  // string unit = 11;
  if (this->unit().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->unit());
  }

  // string standard_unit = 12;
  if (this->standard_unit().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->standard_unit());
  }

  // string display_unit = 13;
  if (this->display_unit().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->display_unit());
  }

  // string format = 14;
  if (this->format().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->format());
  }

  // string min_value = 15;
  if (this->min_value().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->min_value());
  }

  // string max_value = 16;
  if (this->max_value().size() > 0) {
    total_size += 2 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->max_value());
  }

  // string writable_attr_name = 17;
  if (this->writable_attr_name().size() > 0) {
    total_size += 2 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->writable_attr_name());
  }

  // string root_attr_name = 19;
  if (this->root_attr_name().size() > 0) {
    total_size += 2 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->root_attr_name());
  }

  // .mascot.AttributeAlarm att_alarm = 21;
  if (this->has_att_alarm()) {
    total_size += 2 +
      ::google::protobuf::internal::WireFormatLite::MessageSize(
        *this->att_alarm_);
  }

  // .mascot.EventProperties event_prop = 22;
  if (this->has_event_prop()) {
    total_size += 2 +
      ::google::protobuf::internal::WireFormatLite::MessageSize(
        *this->event_prop_);
  }

  // .mascot.AttrWriteType writable = 2;
  if (this->writable() != 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::EnumSize(this->writable());
  }

  // .mascot.AttrDataFormat data_format = 3;
  if (this->data_format() != 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::EnumSize(this->data_format());
  }

  // int64 data_type = 4;
  if (this->data_type() != 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::Int64Size(
        this->data_type());
  }

  // int64 max_dim_x = 7;
  if (this->max_dim_x() != 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::Int64Size(
        this->max_dim_x());
  }

  // int64 max_dim_y = 8;
  if (this->max_dim_y() != 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::Int64Size(
        this->max_dim_y());
  }

  // bool memorized = 5;
  if (this->memorized() != 0) {
    total_size += 1 + 1;
  }

  // bool mem_init = 6;
  if (this->mem_init() != 0) {
    total_size += 1 + 1;
  }

  // .mascot.DispLevel level = 18;
  if (this->level() != 0) {
    total_size += 2 +
      ::google::protobuf::internal::WireFormatLite::EnumSize(this->level());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void AttributeConfig::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.AttributeConfig)
  GOOGLE_DCHECK_NE(&from, this);
  const AttributeConfig* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const AttributeConfig>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.AttributeConfig)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.AttributeConfig)
    MergeFrom(*source);
  }
}

void AttributeConfig::MergeFrom(const AttributeConfig& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.AttributeConfig)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  enum_labels_.MergeFrom(from.enum_labels_);
  extensions_.MergeFrom(from.extensions_);
  sys_extensions_.MergeFrom(from.sys_extensions_);
  if (from.name().size() > 0) {

    name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.name_);
  }
  if (from.description().size() > 0) {

    description_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.description_);
  }
  if (from.label().size() > 0) {

    label_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.label_);
  }
  if (from.unit().size() > 0) {

    unit_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.unit_);
  }
  if (from.standard_unit().size() > 0) {

    standard_unit_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.standard_unit_);
  }
  if (from.display_unit().size() > 0) {

    display_unit_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.display_unit_);
  }
  if (from.format().size() > 0) {

    format_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.format_);
  }
  if (from.min_value().size() > 0) {

    min_value_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.min_value_);
  }
  if (from.max_value().size() > 0) {

    max_value_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.max_value_);
  }
  if (from.writable_attr_name().size() > 0) {

    writable_attr_name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.writable_attr_name_);
  }
  if (from.root_attr_name().size() > 0) {

    root_attr_name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.root_attr_name_);
  }
  if (from.has_att_alarm()) {
    mutable_att_alarm()->::mascot::AttributeAlarm::MergeFrom(from.att_alarm());
  }
  if (from.has_event_prop()) {
    mutable_event_prop()->::mascot::EventProperties::MergeFrom(from.event_prop());
  }
  if (from.writable() != 0) {
    set_writable(from.writable());
  }
  if (from.data_format() != 0) {
    set_data_format(from.data_format());
  }
  if (from.data_type() != 0) {
    set_data_type(from.data_type());
  }
  if (from.max_dim_x() != 0) {
    set_max_dim_x(from.max_dim_x());
  }
  if (from.max_dim_y() != 0) {
    set_max_dim_y(from.max_dim_y());
  }
  if (from.memorized() != 0) {
    set_memorized(from.memorized());
  }
  if (from.mem_init() != 0) {
    set_mem_init(from.mem_init());
  }
  if (from.level() != 0) {
    set_level(from.level());
  }
}

void AttributeConfig::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.AttributeConfig)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void AttributeConfig::CopyFrom(const AttributeConfig& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.AttributeConfig)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool AttributeConfig::IsInitialized() const {
  return true;
}

void AttributeConfig::Swap(AttributeConfig* other) {
  if (other == this) return;
  InternalSwap(other);
}
void AttributeConfig::InternalSwap(AttributeConfig* other) {
  using std::swap;
  enum_labels_.InternalSwap(&other->enum_labels_);
  extensions_.InternalSwap(&other->extensions_);
  sys_extensions_.InternalSwap(&other->sys_extensions_);
  name_.Swap(&other->name_);
  description_.Swap(&other->description_);
  label_.Swap(&other->label_);
  unit_.Swap(&other->unit_);
  standard_unit_.Swap(&other->standard_unit_);
  display_unit_.Swap(&other->display_unit_);
  format_.Swap(&other->format_);
  min_value_.Swap(&other->min_value_);
  max_value_.Swap(&other->max_value_);
  writable_attr_name_.Swap(&other->writable_attr_name_);
  root_attr_name_.Swap(&other->root_attr_name_);
  swap(att_alarm_, other->att_alarm_);
  swap(event_prop_, other->event_prop_);
  swap(writable_, other->writable_);
  swap(data_format_, other->data_format_);
  swap(data_type_, other->data_type_);
  swap(max_dim_x_, other->max_dim_x_);
  swap(max_dim_y_, other->max_dim_y_);
  swap(memorized_, other->memorized_);
  swap(mem_init_, other->mem_init_);
  swap(level_, other->level_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata AttributeConfig::GetMetadata() const {
  protobuf_attribute_5fconfig_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_attribute_5fconfig_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void AttributeConfigReply::InitAsDefaultInstance() {
  ::mascot::_AttributeConfigReply_default_instance_._instance.get_mutable()->error_ = const_cast< ::mascot::Error*>(
      ::mascot::Error::internal_default_instance());
  ::mascot::_AttributeConfigReply_default_instance_._instance.get_mutable()->data_ = const_cast< ::mascot::AttributeConfig*>(
      ::mascot::AttributeConfig::internal_default_instance());
}
void AttributeConfigReply::clear_error() {
  if (GetArenaNoVirtual() == NULL && error_ != NULL) {
    delete error_;
  }
  error_ = NULL;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int AttributeConfigReply::kSuccessFieldNumber;
const int AttributeConfigReply::kErrorFieldNumber;
const int AttributeConfigReply::kDataFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

AttributeConfigReply::AttributeConfigReply()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_attribute_5fconfig_2eproto::InitDefaultsAttributeConfigReply();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.AttributeConfigReply)
}
AttributeConfigReply::AttributeConfigReply(const AttributeConfigReply& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  if (from.has_error()) {
    error_ = new ::mascot::Error(*from.error_);
  } else {
    error_ = NULL;
  }
  if (from.has_data()) {
    data_ = new ::mascot::AttributeConfig(*from.data_);
  } else {
    data_ = NULL;
  }
  success_ = from.success_;
  // @@protoc_insertion_point(copy_constructor:mascot.AttributeConfigReply)
}

void AttributeConfigReply::SharedCtor() {
  ::memset(&error_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&success_) -
      reinterpret_cast<char*>(&error_)) + sizeof(success_));
  _cached_size_ = 0;
}

AttributeConfigReply::~AttributeConfigReply() {
  // @@protoc_insertion_point(destructor:mascot.AttributeConfigReply)
  SharedDtor();
}

void AttributeConfigReply::SharedDtor() {
  if (this != internal_default_instance()) delete error_;
  if (this != internal_default_instance()) delete data_;
}

void AttributeConfigReply::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* AttributeConfigReply::descriptor() {
  ::protobuf_attribute_5fconfig_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_attribute_5fconfig_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const AttributeConfigReply& AttributeConfigReply::default_instance() {
  ::protobuf_attribute_5fconfig_2eproto::InitDefaultsAttributeConfigReply();
  return *internal_default_instance();
}

AttributeConfigReply* AttributeConfigReply::New(::google::protobuf::Arena* arena) const {
  AttributeConfigReply* n = new AttributeConfigReply;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void AttributeConfigReply::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.AttributeConfigReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  if (GetArenaNoVirtual() == NULL && error_ != NULL) {
    delete error_;
  }
  error_ = NULL;
  if (GetArenaNoVirtual() == NULL && data_ != NULL) {
    delete data_;
  }
  data_ = NULL;
  success_ = false;
  _internal_metadata_.Clear();
}

bool AttributeConfigReply::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.AttributeConfigReply)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // bool success = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(8u /* 8 & 0xFF */)) {

          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   bool, ::google::protobuf::internal::WireFormatLite::TYPE_BOOL>(
                 input, &success_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.Error error = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_error()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // .mascot.AttributeConfig data = 3;
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(26u /* 26 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_data()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.AttributeConfigReply)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.AttributeConfigReply)
  return false;
#undef DO_
}

void AttributeConfigReply::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.AttributeConfigReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // bool success = 1;
  if (this->success() != 0) {
    ::google::protobuf::internal::WireFormatLite::WriteBool(1, this->success(), output);
  }

  // .mascot.Error error = 2;
  if (this->has_error()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      2, *this->error_, output);
  }

  // .mascot.AttributeConfig data = 3;
  if (this->has_data()) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      3, *this->data_, output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.AttributeConfigReply)
}

::google::protobuf::uint8* AttributeConfigReply::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.AttributeConfigReply)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // bool success = 1;
  if (this->success() != 0) {
    target = ::google::protobuf::internal::WireFormatLite::WriteBoolToArray(1, this->success(), target);
  }

  // .mascot.Error error = 2;
  if (this->has_error()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        2, *this->error_, deterministic, target);
  }

  // .mascot.AttributeConfig data = 3;
  if (this->has_data()) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        3, *this->data_, deterministic, target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.AttributeConfigReply)
  return target;
}

size_t AttributeConfigReply::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.AttributeConfigReply)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // .mascot.Error error = 2;
  if (this->has_error()) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::MessageSize(
        *this->error_);
  }

  // .mascot.AttributeConfig data = 3;
  if (this->has_data()) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::MessageSize(
        *this->data_);
  }

  // bool success = 1;
  if (this->success() != 0) {
    total_size += 1 + 1;
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void AttributeConfigReply::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.AttributeConfigReply)
  GOOGLE_DCHECK_NE(&from, this);
  const AttributeConfigReply* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const AttributeConfigReply>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.AttributeConfigReply)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.AttributeConfigReply)
    MergeFrom(*source);
  }
}

void AttributeConfigReply::MergeFrom(const AttributeConfigReply& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.AttributeConfigReply)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.has_error()) {
    mutable_error()->::mascot::Error::MergeFrom(from.error());
  }
  if (from.has_data()) {
    mutable_data()->::mascot::AttributeConfig::MergeFrom(from.data());
  }
  if (from.success() != 0) {
    set_success(from.success());
  }
}

void AttributeConfigReply::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.AttributeConfigReply)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void AttributeConfigReply::CopyFrom(const AttributeConfigReply& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.AttributeConfigReply)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool AttributeConfigReply::IsInitialized() const {
  return true;
}

void AttributeConfigReply::Swap(AttributeConfigReply* other) {
  if (other == this) return;
  InternalSwap(other);
}
void AttributeConfigReply::InternalSwap(AttributeConfigReply* other) {
  using std::swap;
  swap(error_, other->error_);
  swap(data_, other->data_);
  swap(success_, other->success_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata AttributeConfigReply::GetMetadata() const {
  protobuf_attribute_5fconfig_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_attribute_5fconfig_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void EventProperties::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int EventProperties::kEmptyFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

EventProperties::EventProperties()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_attribute_5fconfig_2eproto::InitDefaultsEventProperties();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.EventProperties)
}
EventProperties::EventProperties(const EventProperties& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  empty_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.empty().size() > 0) {
    empty_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.empty_);
  }
  // @@protoc_insertion_point(copy_constructor:mascot.EventProperties)
}

void EventProperties::SharedCtor() {
  empty_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _cached_size_ = 0;
}

EventProperties::~EventProperties() {
  // @@protoc_insertion_point(destructor:mascot.EventProperties)
  SharedDtor();
}

void EventProperties::SharedDtor() {
  empty_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void EventProperties::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* EventProperties::descriptor() {
  ::protobuf_attribute_5fconfig_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_attribute_5fconfig_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const EventProperties& EventProperties::default_instance() {
  ::protobuf_attribute_5fconfig_2eproto::InitDefaultsEventProperties();
  return *internal_default_instance();
}

EventProperties* EventProperties::New(::google::protobuf::Arena* arena) const {
  EventProperties* n = new EventProperties;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void EventProperties::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.EventProperties)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  empty_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _internal_metadata_.Clear();
}

bool EventProperties::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.EventProperties)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // string empty = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_empty()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->empty().data(), static_cast<int>(this->empty().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.EventProperties.empty"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.EventProperties)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.EventProperties)
  return false;
#undef DO_
}

void EventProperties::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.EventProperties)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string empty = 1;
  if (this->empty().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->empty().data(), static_cast<int>(this->empty().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.EventProperties.empty");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->empty(), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.EventProperties)
}

::google::protobuf::uint8* EventProperties::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.EventProperties)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string empty = 1;
  if (this->empty().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->empty().data(), static_cast<int>(this->empty().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.EventProperties.empty");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->empty(), target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.EventProperties)
  return target;
}

size_t EventProperties::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.EventProperties)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // string empty = 1;
  if (this->empty().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->empty());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void EventProperties::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.EventProperties)
  GOOGLE_DCHECK_NE(&from, this);
  const EventProperties* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const EventProperties>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.EventProperties)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.EventProperties)
    MergeFrom(*source);
  }
}

void EventProperties::MergeFrom(const EventProperties& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.EventProperties)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.empty().size() > 0) {

    empty_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.empty_);
  }
}

void EventProperties::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.EventProperties)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void EventProperties::CopyFrom(const EventProperties& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.EventProperties)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool EventProperties::IsInitialized() const {
  return true;
}

void EventProperties::Swap(EventProperties* other) {
  if (other == this) return;
  InternalSwap(other);
}
void EventProperties::InternalSwap(EventProperties* other) {
  using std::swap;
  empty_.Swap(&other->empty_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata EventProperties::GetMetadata() const {
  protobuf_attribute_5fconfig_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_attribute_5fconfig_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void AttributeAlarm::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int AttributeAlarm::kEmptyFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

AttributeAlarm::AttributeAlarm()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_attribute_5fconfig_2eproto::InitDefaultsAttributeAlarm();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:mascot.AttributeAlarm)
}
AttributeAlarm::AttributeAlarm(const AttributeAlarm& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  empty_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.empty().size() > 0) {
    empty_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.empty_);
  }
  // @@protoc_insertion_point(copy_constructor:mascot.AttributeAlarm)
}

void AttributeAlarm::SharedCtor() {
  empty_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _cached_size_ = 0;
}

AttributeAlarm::~AttributeAlarm() {
  // @@protoc_insertion_point(destructor:mascot.AttributeAlarm)
  SharedDtor();
}

void AttributeAlarm::SharedDtor() {
  empty_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void AttributeAlarm::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* AttributeAlarm::descriptor() {
  ::protobuf_attribute_5fconfig_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_attribute_5fconfig_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const AttributeAlarm& AttributeAlarm::default_instance() {
  ::protobuf_attribute_5fconfig_2eproto::InitDefaultsAttributeAlarm();
  return *internal_default_instance();
}

AttributeAlarm* AttributeAlarm::New(::google::protobuf::Arena* arena) const {
  AttributeAlarm* n = new AttributeAlarm;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void AttributeAlarm::Clear() {
// @@protoc_insertion_point(message_clear_start:mascot.AttributeAlarm)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  empty_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  _internal_metadata_.Clear();
}

bool AttributeAlarm::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:mascot.AttributeAlarm)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // string empty = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_empty()));
          DO_(::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
            this->empty().data(), static_cast<int>(this->empty().length()),
            ::google::protobuf::internal::WireFormatLite::PARSE,
            "mascot.AttributeAlarm.empty"));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:mascot.AttributeAlarm)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:mascot.AttributeAlarm)
  return false;
#undef DO_
}

void AttributeAlarm::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:mascot.AttributeAlarm)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string empty = 1;
  if (this->empty().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->empty().data(), static_cast<int>(this->empty().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeAlarm.empty");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->empty(), output);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), output);
  }
  // @@protoc_insertion_point(serialize_end:mascot.AttributeAlarm)
}

::google::protobuf::uint8* AttributeAlarm::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:mascot.AttributeAlarm)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  // string empty = 1;
  if (this->empty().size() > 0) {
    ::google::protobuf::internal::WireFormatLite::VerifyUtf8String(
      this->empty().data(), static_cast<int>(this->empty().length()),
      ::google::protobuf::internal::WireFormatLite::SERIALIZE,
      "mascot.AttributeAlarm.empty");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->empty(), target);
  }

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:mascot.AttributeAlarm)
  return target;
}

size_t AttributeAlarm::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:mascot.AttributeAlarm)
  size_t total_size = 0;

  if ((_internal_metadata_.have_unknown_fields() &&  ::google::protobuf::internal::GetProto3PreserveUnknownsDefault())) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        (::google::protobuf::internal::GetProto3PreserveUnknownsDefault()   ? _internal_metadata_.unknown_fields()   : _internal_metadata_.default_instance()));
  }
  // string empty = 1;
  if (this->empty().size() > 0) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->empty());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void AttributeAlarm::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:mascot.AttributeAlarm)
  GOOGLE_DCHECK_NE(&from, this);
  const AttributeAlarm* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const AttributeAlarm>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:mascot.AttributeAlarm)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:mascot.AttributeAlarm)
    MergeFrom(*source);
  }
}

void AttributeAlarm::MergeFrom(const AttributeAlarm& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:mascot.AttributeAlarm)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  if (from.empty().size() > 0) {

    empty_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.empty_);
  }
}

void AttributeAlarm::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:mascot.AttributeAlarm)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void AttributeAlarm::CopyFrom(const AttributeAlarm& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:mascot.AttributeAlarm)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool AttributeAlarm::IsInitialized() const {
  return true;
}

void AttributeAlarm::Swap(AttributeAlarm* other) {
  if (other == this) return;
  InternalSwap(other);
}
void AttributeAlarm::InternalSwap(AttributeAlarm* other) {
  using std::swap;
  empty_.Swap(&other->empty_);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata AttributeAlarm::GetMetadata() const {
  protobuf_attribute_5fconfig_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_attribute_5fconfig_2eproto::file_level_metadata[kIndexInFileMessages];
}


// @@protoc_insertion_point(namespace_scope)
}  // namespace mascot

// @@protoc_insertion_point(global_scope)
